#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <fcntl.h>
#include <unistd.h>

/* nombre de threads traitant les jobs (Q2.2)*/
#define MAX_PARALLEL_JOBS 4

/* nombre de jobs à traiter */
#define NJOBS 40

/* fichier dans lequel doivent être écrits les résultats */
#define FILE_NAME "results.dat"

/* calcule le resultat du job 'job_id' */
#define RESULT(job_id) (((job_id)+17)%13)


struct job_t {
  int job_id;			/* identifiant du job */
  int res;			/* resultat du job */
  struct job_t *next;		/* pointeur vers le job suivant */
};
/* pointeur vers le premier job de la liste */
struct job_t *jobs = NULL;


/* A COMPLETER:
 * déclarer les éventuelles variables globales
 */


/* traite un job */
void process_job(struct job_t*j) {
  printf("Processing job %d\n", j->job_id);
  usleep(10000*j->job_id);
  j->res = RESULT(j->job_id);
}

/* enregistre le résultat d'un job dans le fichier */
void save_result(struct job_t*j) {
  /* Q2.1: A COMPLETER
   * ecrire j->res au bon endroit dans le fichier
   */
}


/* traiter les jobs soumis */
void traiter_jobs() {

  while(1) {
    /* on prend un job de la liste */
    struct job_t*j = jobs;
    if(jobs) {
      jobs = jobs->next;
    } else {
      /* il n'y a plus de job à traiter. On s'arrête */
      return;
    }
    /* on traite le job j, et on enregistre le résultat */
    process_job(j);
    save_result(j);
    free(j);
  }
}

/* initialise le traitement des jobs */
void init_workers() {
  /* Q2.1: A COMPLETER
   * ouvrir le fichier FILE_NAME
   */
}

/* attend la fin du traitement des jobs et fait le ménage */
void finalize_workers() {
  traiter_jobs();

  /* Q2.1: A COMPLETER
   * fermer le fichier
   */
}


/* crée un nouveau job et le soumet */
void submit_job(int n) {
  struct job_t *j = malloc(sizeof(struct job_t));
  assert(j != NULL);
  j->job_id = n;
  j->res = -1;

  /* ajoute le job dans la liste chaînée */
  j->next = jobs;
  jobs = j;
}

/* vérifie que le fichier résultat contient les bon résultats */
void check_result() {
  /* NE PAS MODIFIER CETTE FONCTION */
  int i;
  int fd = open(FILE_NAME, O_RDONLY);
  assert(fd>0);
  printf("\nChecking if file contents is correct...\n");
  for(i=0; i<NJOBS; i++) {
    int val;
    int ret = read(fd, &val, sizeof(int));
    assert(ret==sizeof(int));
    if(val != RESULT(i)) {
      printf("\tIncorrect contents!\n");
      abort();
    }
  }
  printf("PASSED\n");
  close(fd);
}

int main(int argc, char** argv) {
  /* NE PAS MODIFIER CETTE FONCTION */
  init_workers();
  int i;
  for(i=0; i<NJOBS; i++) {
    submit_job(i);
  }
  finalize_workers();


  check_result();
  return 0;
}
