#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <assert.h>
#include <errno.h>
#include <string.h>
#include <pthread.h>

/* compte le nombre d'entrées de type fichier dans un répertoire */
int count_files(char* dirname) {
  int ret = 0;

  /* ouvre le répertoire */
  DIR*d = opendir(dirname);
  if(!d) {
    perror("opendir");
    exit(1);
  }

  struct dirent* de = NULL;
  /* on parcourt toutes les entrées du répertoire */
  while((de = readdir(d))!= NULL) {
    /* parmi les entrées, '.' et '..' ne nous intéressent pas. Ignorons les */
    if(strcmp(de->d_name, ".") != 0 && strcmp(de->d_name, "..") != 0) {
      if(de->d_type == DT_REG) { /* l'entrée est un fichier régulier */
	ret++;
      }
    }
  }

  /* ferme le répertoire */
  closedir(d);

  return ret;
}

int main(int argc, char**argv) {
  if(argc != 2) {
    fprintf(stderr, "Usage: %s <directory>\n", argv[0]);
     return EXIT_FAILURE;
  }

  /* on crée une copie du nom de répertoire */
  int len = strlen(argv[1]) + 1;
  char* str = malloc(sizeof(char)*len);
  snprintf(str, len, "%s", argv[1]);


  int nb_fichiers = count_files(str);

  printf("Il y a %d fichiers dans le répertoire %s\n", nb_fichiers, str);

  return EXIT_SUCCESS;
}
